<?php
/**********************************************\
| SMFSHOP (Shop MOD for Simple Machines Forum) |
|         (c) 2006 DanSoft Australia           |
|      http://www.dansoftaustralia.net/        |
\**********************************************/

//File: Shop-Inventory.php
//      Inventory stuff (view inventory, use item, view other's inventory)
//		This is not called directly. The code in here is used in Shop.php

// VERSION: 2.3 (Build 11)
// $Date: 2006-10-21 13:34:18 +1000 (Sat, 21 Oct 2006) $
// $Id: Shop-Inventory.php 24 2006-10-21 03:34:18Z daniel15 $

// If this script isn't called by SMF, it's bad!
if (!defined('SMF'))
	die('Hacking attempt...');

// Viewing your inventory
if ($_GET['do'] == "inv") {
	$context['linktree'][] = array(
		'url' => "$scripturl?action=shop;do=inv",
		'name' => $txt['shop_yourinv'],
	);

	// Start the items list
	$context['shop_items_list'] = "
		<tr valign='top' class='windowbg'>
			<td style='padding-bottom: 2ex;' width='32'>
				<b>{$txt['shop_image']}</b>
			</td>
			<td>
				<b>{$txt['shop_name']}</b>
			</td>
			<td>
				<b>{$txt['shop_description']}</b>
			</td>
			<td width='18%'>
				<b>Paid/Use</b>
			</td>
		</tr>";

	// Alternating row background - Start at windowbg2
	$alternating = "windowbg2";
	// Start with a blank array
	$itemRows = array();

	// Get all inventory items
	$result = db_query("SELECT it.name, it.desc, it.input_needed, it.can_use_item, it.image,
							   inv.amtpaid, inv.id, inv.trading, inv.tradecost
						FROM {$db_prefix}shop_inventory AS inv, {$db_prefix}shop_items AS it
						WHERE inv.ownerid = {$ID_MEMBER} AND inv.itemid = it.id
						ORDER BY it.name ASC",
						__FILE__, __LINE__);

	// Add all items to the array
	while ($row = mysql_fetch_array($result, MYSQL_ASSOC)) $itemRows[] = $row;

	// If page not set, assume you want page 1
	if (!isset($_GET['page'])) $_GET['page'] = 1;
	// If 'Items per page' not set, assume 15 per page
	if (!isset($modSettings['shopItemsPerPage'])) $modSettings['shopItemsPerPage'] = 15;
	
	// Number of pages is number of items divided by items per page
	$pageCount = ceil(count($itemRows) / $modSettings['shopItemsPerPage']);
	// The first item to display
	$firstItem = ($_GET['page'] * $modSettings['shopItemsPerPage']) - $modSettings['shopItemsPerPage'];
	
	// Loop through all items on the specified page
	for ($x = $firstItem; ($x < $firstItem + $modSettings['shopItemsPerPage']) && ($x < count($itemRows)) ; $x++) {
		// Add these items to the list
		$context['shop_items_list'] .= "
			<tr valign='top' class='{$alternating}'>
				<td>
					<img border='0' width='{$modSettings['shopImageWidth']}' height='{$modSettings['shopImageHeight']}' src='{$boardurl}/Sources/shop/item_images/{$itemRows[$x]['image']}' alt='Item Image' />
				</td>
				<td style='padding-bottom: 2ex;' width='20%'>
					{$itemRows[$x]['name']}
				</td>
				<td>
					{$itemRows[$x]['desc']}
				</td>
				<td width='18%'>
					Paid: {$itemRows[$x]['amtpaid']}<br />";

		// The order of the if statements here is important!
		// If the item is in the trade centre
		if ($itemRows[$x]['trading'] == 1) {
			// Tell them that they can't use it, and give the option to stop trading
			$context['shop_items_list'] .= "<i>".sprintf($txt['shop_trading'], formatMoney($itemRows[$x]['tradecost']))."</i><br /><a href='$scripturl?action=shop;do=trade_stop;id={$itemRows[$x]['id']}'>{$txt['shop_stoptrade']}</a>";
		} else {
			// If the item is unusable
			if ($itemRows[$x]['can_use_item'] == false) {
				$context['shop_items_list'] .= "<b>{$txt['shop_unusable']}</b>";
			// If no input is needed for the item - Go straight to inv3
			} elseif ($itemRows[$x]['input_needed'] == false) {
				$context['shop_items_list'] .= "<a href='{$scripturl}?action=shop;do=inv3;id={$itemRows[$x]['id']}'>{$txt['shop_use']}</a>";
			// If the item requires input - Go to inv2
			} else {
				$context['shop_items_list'] .= "<a href='{$scripturl}?action=shop;do=inv2;id={$itemRows[$x]['id']}'>{$txt['shop_use']}</a>";
			}
			
			// If the trade centre is enabled...
			if ($modSettings['shopTradeEnabled'])
				//... show the 'Trade Item' link
				$context['shop_items_list'] .= "<br /><a href='{$scripturl}?action=shop;do=trade_sell;id={$itemRows[$x]['id']}'>{$txt['shop_tradeitem']}</a>";
		}
	
		// Close the table row
		$context['shop_items_list'] .= "</td></tr>";

		// Toggle the background to use
		$alternating = ($alternating == "windowbg") ? 'windowbg2' : 'windowbg';
	}
	
	// Set some miscellaneous variables
	$context['shop_pages'] = $pageCount;
	$context['shop_current_page'] = $_GET['page'];
	$context['shop_page_link'] = $scripturl."?action=shop;do=inv";
	// Set the page title
	$context['page_title'] = $txt['shop'].' - '.$txt['shop_yourinv'];
	// Use the inventory template
	$context['sub_template'] = "inventory";
	loadTemplate('Shop');
		
// Inv2 - Using an item, and user needs to enter some input
} elseif ($_GET['do'] == "inv2") {
	$context['linktree'][] = array(
		'url' => "$scripturl?action=shop;do=inv",
		'name' => $txt['shop_yourinv'],
	);

	// Make sure input was numeric
	$_GET['id'] = (int) $_GET['id'];
	
	// Get the item's information
	$result = db_query("SELECT it.module, it.can_use_item, it.info1, it.info2, it.info3,
							   it.info4, inv.ownerid
						FROM {$db_prefix}shop_inventory AS inv, {$db_prefix}shop_items AS it
						WHERE inv.id = {$_GET['id']} AND inv.itemid = it.id
						LIMIT 1", __FILE__, __LINE__);

	$row = mysql_fetch_array($result, MYSQL_ASSOC);
	// Trying to use other person's item? Nope, not here ;)
	if ($row['ownerid'] !== $ID_MEMBER) {
		die($txt['shop_use_others_item']);
	// If the item is unusable
	} elseif ($row['can_use_item'] == false) {
		die($txt['shop_unusable']);
	}

	// Show the 'Item Requires Input' message, and start the form
	$context['shop_buy_message'] = "{$txt['shop_input']}<br />
		 <form action='$scripturl?action=shop;do=inv3;id={$_GET['id']}' method='post'>";


	// Additional info, just in case it's needed in getUseInput() function
	$item_info[1] = $row['info1'];
	$item_info[2] = $row['info2'];
	$item_info[3] = $row['info3'];
	$item_info[4] = $row['info4'];

	// Include the item engine...
	require("$sourcedir/shop/item_engine.php");
	//... and the actual item.
	require("$sourcedir/shop/items/{$row['module']}.php");
	// Create the item, ...
	eval("\$temp = new item_{$row['module']};");
	// ...get the input required...
	$context['shop_buy_message'] .= $temp->getUseInput();
	// ... and show the submit button!
	$context['shop_buy_message'] .= "<br /><input type='submit' value='{$txt['shop_use']}'></form>";
	
	// Set the page title
	$context['page_title'] = $txt['shop'].' - '.$txt['shop_yourinv'];
	// Use the 'message' template
	$context['sub_template'] = "message";
	loadTemplate('Shop');
		
// Inv3 - Final stages of using the item
} elseif ($_GET['do'] == "inv3") {
	$context['linktree'][] = array(
		'url' => "$scripturl?action=shop;do=inv",
		'name' => $txt['shop_yourinv'],
	);

	// Make sure input is numeric
	$_GET['id'] = (int) $_GET['id'];
	// Get the item's information
	$result = db_query("SELECT it.module, it.can_use_item, it.info1, it.info2, it.info3,
							   it.info4, inv.ownerid
						FROM {$db_prefix}shop_inventory AS inv, {$db_prefix}shop_items AS it
						WHERE inv.id = {$_GET['id']} AND inv.itemid = it.id
						LIMIT 1", __FILE__, __LINE__);

	$row = mysql_fetch_array($result, MYSQL_ASSOC);
	// Trying to use someone else's item? Nice try! :P
	if ($row['ownerid'] !== $ID_MEMBER) {
		die($txt['shop_use_others_item2']);
	// Sorry, item is a rock (unusable)
	} elseif ($row['can_use_item'] == false) {
		die($txt['shop_unusable']);
	}

	// Additional information used by the item (entered by admin when adding item)
	$item_info[1] = $row['info1'];
	$item_info[2] = $row['info2'];
	$item_info[3] = $row['info3'];
	$item_info[4] = $row['info4'];

	// Require the item engine ...
	require("{$sourcedir}/shop/item_engine.php");
	// ... and the actual item.
	require("{$sourcedir}/shop/items/{$row['module']}.php");

	// Create an instance of the item
	eval("\$temp = new item_{$row['module']};");
	// Now, do the actual action!
	$context['shop_buy_message'] = $temp->onUse();
	// And show the 'Back to Inventory' link
	$context['shop_buy_message'] .= "<br /><br /><a href='$scripturl?action=shop;do=inv'>{$txt['shop_back2inv']}</a>";

	// If we got here, everything worked OK. Remove the item from the user's inventory
	$result = db_query("DELETE FROM {$db_prefix}shop_inventory
						WHERE id = {$_GET['id']}
						LIMIT 1", 
						__FILE__, __LINE__);

	// Set the page title
	$context['page_title'] = $txt['shop'].' - '.$txt['shop_yourinv'];						
	// Use the message template
	$context['sub_template'] = "message";
	loadTemplate('Shop');
	
// View another member's inventory
} elseif ($_GET['do'] == "invother") {
	
	$context['linktree'][] = array(
		'url' => "$scripturl?action=shop;do=invother",
		'name' => $txt['shop_invother'],
	);
	
	// This is simple: Set the page title, and show the template!
	$context['page_title'] = $txt['shop'].' - '.$txt['shop_invother'];
	$context['sub_template'] = "otherInventory";
	loadTemplate('Shop');
	
// View another member's inventory - Form was submitted, and a name was entered
} elseif ($_GET['do'] == "invother2") {

	 $context['linktree'][] = array(
		'url' => "$scripturl?action=shop;do=invother",
		'name' => $txt['shop_invother'],
	);

	// Get the user's details
	$result = db_query("SELECT ID_MEMBER, memberName, realName
						  FROM {$db_prefix}members
						  WHERE memberName = '{$_REQUEST['member']}'
						  LIMIT 1", __FILE__, __LINE__);
	$row = mysql_fetch_array($result, MYSQL_ASSOC);

	// If the number of results is 0, or the names don't match
	if (mysql_num_rows($result) == 0 || $row['memberName'] <> $_REQUEST['member']) {
		// Sorry, but this user doesn't exist!
		die(sprintf($txt['shop_member_no_exist'], $_REQUEST['member']));
	}
	
	// Their ID
	$usersid = $row['ID_MEMBER'];
	// Their real name (display name)
	$usersname = $row['realName'];

	$context['linktree'][] = array(
		'url' => "$scripturl?action=shop;do=invother2;member={$_REQUEST['member']}",
		'name' => sprintf($txt['shop_viewing_inv'], $usersid, $usersname),
	);

	// Start the list
	$context['shop_items_list'] = "
		<tr>
		   <td colspan='3'>
			   <div align='center'><b>Below is a list of all the items member ID {$usersid} ({$usersname}) has:</b></div>
		   </td>
		</tr>
		<tr valign='top' class='windowbg'>
			<td style='padding-bottom: 2ex;' width='32'>
				<b>{$txt['shop_image']}</b>
			</td>
			<td>
				<b>{$txt['shop_name']}</b>
			</td>
			<td>
				<b>{$txt['shop_description']}</b>
			</td>
		</tr>";
	$alternating = "windowbg2";
	// Get all of their inventory items
	$result = db_query("SELECT it.name, it.desc, it.image, inv.id
						FROM {$db_prefix}shop_inventory AS inv, {$db_prefix}shop_items AS it
						WHERE ownerid = {$usersid} AND inv.itemid = it.id",
						__FILE__, __LINE__);

	// Loop through all the items
	while ($row = mysql_fetch_array($result, MYSQL_ASSOC)) {
		// Add the item to the list
		$context['shop_items_list'] .= "
			<tr valign='top' class='{$alternating}'>
				<td>
					<img border='0' width='32' height='32' src='{$boardurl}/Sources/shop/item_images/{$row['image']}' alt='Item Image' />
				</td>
				<td style='padding-bottom: 2ex;' width='20%'>
					{$row['name']}
				</td>
				<td>
					{$row['desc']}
				</td>";

		$alternating =  ($alternating == "windowbg") ? 'windowbg2' : 'windowbg';
	}

	// Set the page title
	$context['page_title'] = $txt['shop'].' - '.$txt['shop_invother'];		
	// Use the inventory template
	$context['sub_template'] = "inventory";
	loadTemplate('Shop');
}
?>
