<?php
/**********************************************\
| SMFSHOP (Shop MOD for Simple Machines Forum) |
|         (c) 2006 DanSoft Australia           |
|      http://www.dansoftaustralia.net/        |
\**********************************************/

//File: Shop.php
//	  The main shop file

// VERSION: 2.3 (Build 11)
// $Date: 2006-10-21 13:34:18 +1000 (Sat, 21 Oct 2006) $
// $Id: Shop.php 24 2006-10-21 03:34:18Z daniel15 $

// If file is not called by SMF, don't let them get anywhere!
if (!defined('SMF'))
	die('Hacking attempt...');

function Shop(){
	global $context, $modSettings, $scripturl, $db_prefix, $ID_MEMBER, $txt, $item_info, $boardurl, $sourcedir;
	
	//Required for sending IM's
	include_once($sourcedir . '/Subs-Post.php');
	// SMF 1.1 uses PersonalMessage, whereas SMF 1.0 uses InstantMessage
	// We try to load both, so that this this will work with either SMF version.
	loadLanguage('PersonalMessage', '', false);
	loadLanguage('InstantMessage', '', false);
	
	// During testing, caching was causing many problems. So, we try to disable the caching
	// here.
	header("Expires: Fri, 1 Jun 1990 00:00:00 GMT"); //my birthday ;)
	header("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT");
	header("Pragma: no-cache");

	// Load the SMFShop language files
	loadLanguage('Shop');
	// Check if guest is trying to access the shop. If so, give them an error 
	is_not_guest($txt['shop_guest_message']);

	// Set the link tree
	$context['linktree'][] = array(
		'url' => "$scripturl?action=shop",
		'name' => $txt['shop'],
		);

	// Check if the bank is enabled...
	// TODO: Maybe move this to the template?
	$context['shop_bank_link'] = ($modSettings['shopBankEnabled']) ? "<a href='$scripturl?action=shop;do=bank'>{$txt['shop_bank']}</a><br />" : "";
	
	// If trade centre disabled, don't show it.
	$context['shop_trade_link'] = ($modSettings['shopTradeEnabled']) ? "<a href='$scripturl?action=shop;do=trade'>{$txt['shop_trade']}</a><br />" : "";

	// If no action passed, or we're going to the home section
	if (empty($_GET['do']) || $_GET['do'] == "home") {
		// Add this to the link tree
		$context['linktree'][] = array(
			'url' => "$scripturl?action=shop",
			'name' => "{$txt['shop']} Home",
		); 

		// 10 richest people (pocket)
		$context['shop_richest'] = "";
		// Get the richest people
		$result = db_query("SELECT realName, money
							FROM {$db_prefix}members
							ORDER BY money DESC, realName
							LIMIT 10", __FILE__, __LINE__);
		// Loop through all results
		while ($row = mysql_fetch_array($result, MYSQL_ASSOC))
			// And add them to the list
			$context['shop_richest'] .= "<b>{$row['realName']}</b> - ".formatMoney($row['money'])."<br />\r\n";

		// 10 richest people (pocket)
		$context['shop_richestBank'] = "";
		// Get the richest people
		$result = db_query("SELECT realName, moneyBank
							FROM {$db_prefix}members
							ORDER BY moneyBank DESC, realName
							LIMIT 10", __FILE__, __LINE__);
		// Loop through all results
		while ($row = mysql_fetch_array($result, MYSQL_ASSOC))
			// Add them to the list
			$context['shop_richestBank'] .= "<b>{$row['realName']}</b> - ".formatMoney($row['moneyBank'])."<br />\r\n";

		// Get the number of credits per new topic and post
		$context['shop_newtopic'] = formatMoney($modSettings['shopPointsPerTopic']);
		$context['shop_newpost'] = formatMoney($modSettings['shopPointsPerPost']);

		// The current member's money
		$result = db_query("SELECT money, moneyBank
							FROM {$db_prefix}members
							WHERE ID_MEMBER = $ID_MEMBER
							LIMIT 1", __FILE__, __LINE__);
		
		$row = mysql_fetch_array($result, MYSQL_ASSOC);

		// Format their money values
		$context['shop_money'] = formatMoney($row['money']);
		$context['shop_money_bank'] = formatMoney($row['moneyBank']);
		
		// If bank is enabled, show the bank interest...
		$context['shop_bank_info'] = ($modSettings['shopBankEnabled']) ? "<br /><b>{$txt['shop_bankinterest']}: </b>{$modSettings['shopInterest']}% per day<br />" : '';
		//... and the current amount of money in the bank
		$context['shop_money_in_bank'] = ($modSettings['shopBankEnabled']) ? "<b>{$txt['shop_money_in_bank']}: </b>{$context['shop_money_bank']}" : '';

		// Set the page title
		$context['page_title'] = $txt['shop'];
		// Main template for the main page :)	
		$context['sub_template'] = "main";
		// Actually load the template
		loadTemplate('Shop');

	// All of this code is in external files, to keep this Shop.php file relatively small :)
	// Some of the smaller, miscellaneous functions are still in this file.
	} elseif (substr($_GET['do'], 0, 3) == "buy") { // Buy an item
		require "Shop-Buy.php";
	} elseif (substr($_GET['do'], 0, 3) == "inv" || substr($_GET['do'], 0, 8) == "invother") { // View inventory
		require "Shop-Inventory.php";
	} elseif (substr($_GET['do'], 0, 4) == "send") { //Send money
		require "Shop-Send.php";
	} elseif (substr($_GET['do'], 0, 4) == "bank" || $_GET['do'] == "deposit" || $_GET['do'] == "withdraw") { //Bank stuff
		require "Shop-Bank.php";
	} elseif (substr($_GET['do'], 0, 5) == "trade") { //Trade Centre
		require "Shop-Trade.php";
		
	// View all members by money in their pocket
	} elseif($_GET['do'] == "viewall") {

		// Add to the link tree
		$context['linktree'][] = array(
			'url' => "$scripturl?action=shop;do=viewall",
			'name' => $txt['shop_view_all'],
		);

		$context['shop_buy_message'] = "";
		// Get actual list of people (money != 0)
		$result = db_query("SELECT memberName, money
							FROM {$db_prefix}members
							WHERE money <> 0
							ORDER BY money DESC
							", __FILE__, __LINE__);

		// Loop through results
		while ($row = mysql_fetch_array($result, MYSQL_ASSOC))
			// Add user to the list
			$context['shop_buy_message'] .= "<b>{$row['memberName']}</b> - ".formatMoney($row['money'])."<br />\r\n";
		
		// Set the page title
		$context['page_title'] = $txt['shop']." - ".$txt['shop_view_all'];
		// Use the message template
		$context['sub_template'] = "message";
		// Load the template
		loadTemplate('Shop');

	// Similar to above, except for money in the bank
	} elseif($_GET['do'] == "viewallBank") {

		// Add to the link tree
		$context['linktree'][] = array(
			'url' => "$scripturl?action=shop;do=viewallBank",
			'name' => $txt['shop_view_all2'],
		);

		$context['shop_buy_message'] = "";
		// Get actual list of people (moneyBank != 0)
		$result = db_query("SELECT memberName, moneyBank
							FROM {$db_prefix}members
							WHERE moneyBank <> 0
							ORDER BY moneyBank DESC
							", __FILE__, __LINE__);

		// Loop through results
		while ($row = mysql_fetch_array($result, MYSQL_ASSOC))
			// Add them to the list
			$context['shop_buy_message'] .= "<b>{$row['memberName']}</b> - ".formatMoney($row['moneyBank'])."<br />\r\n";
		
		// Set the page title
		$context['page_title'] = $txt['shop']." - ".$txt['shop_view_all2'];
		// Use the message template
		$context['sub_template'] = "message";
		// Actually load the template
		loadTemplate('Shop');

	// 'Who Owns This Item' option
	} elseif($_GET['do'] == "owners") {
		// Make sure item ID is a number
		$_GET['id'] = (int) $_GET['id'];
		
		// Get item name
		$result = db_query("SELECT name
							 FROM {$db_prefix}shop_items
							 WHERE id = {$_GET['id']}
							 LIMIT 1", __FILE__, __LINE__);
							 
		$row = mysql_fetch_assoc($result);

		// Add to the linktree
		$context['linktree'][] = array(
			'url' => "$scripturl?action=shop;do=owners;id={$_GET['id']}",
			'name' => $txt['shop_owners'].' - '.$row['name'],
		);
							 
		// Now, get the actual usernames
		// If user has more than one of this item, only count them once
		$result = db_query("SELECT DISTINCT m.realName
							 FROM {$db_prefix}shop_inventory AS inv, {$db_prefix}shop_items AS it, {$db_prefix}members AS m
							 WHERE inv.itemid = {$_GET['id']} AND m.ID_MEMBER = inv.ownerid", __FILE__, __LINE__);
							 
		// Add the header to the message (xx users own the item xx)
		$context['shop_buy_message'] = "<b>".sprintf($txt['shop_users_own_item'], (int) mysql_num_rows($result), $row['name'])."</b><ul>";
									 
		// Loop through results
		while ($rowUser = mysql_fetch_assoc($result))
			// Add user to the list
			$context['shop_buy_message'] .= "<li>".$rowUser['realName']."</li>";
		
		// Close the list
		$context['shop_buy_message'] .= "</ul>";
		// Set the page title
		$context['page_title'] = $txt['shop'].' - '.$txt['shop_owners'].' - '.$row['name'];
		// Use the message template
		$context['sub_template'] = "message";
		// Load the actual template
		loadTemplate('Shop');
	// Otherwise... What do you want us to do?
	} else {
		die("<span style='color: red; font-weight: bold;'>ERROR: The 'do' action you passed was not valid!</span>");
	}
}

// Write the money in a suitable format.
// Casts the value to a float, and add the prefix and suffix
function formatMoney($money) {
	global $modSettings;

	// Cast to float
	$money = (float) $money;
	// Return amount with prefix and suffix added
	return $modSettings['shopCurrencyPrefix'].$money.$modSettings['shopCurrencySuffix'];
}
?>
