<?php
/**********************************************\
| SMFSHOP (Shop MOD for Simple Machines Forum) |
|         (c) 2006 DanSoft Australia           |
|      http://www.dansoftaustralia.net/        |
\**********************************************/

//File: item_engine.php
//      Item back engine [what else can i call it...? ;)]

// Basically, this is a bare-bones item. All the defaults are defined here.
// So, if anything isn't defined by the item, the defaults are inherited from here

// VERSION: 2.3 (Build 11)
// $Date: 2006-10-21 13:34:18 +1000 (Sat, 21 Oct 2006) $
// $Id: item_engine.php 24 2006-10-21 03:34:18Z daniel15 $

class itemTemplate {
	// All the below fields aren't in the item files themselves. They're just defaults
	// The correct values are filled in in the getItemDetails() function inside the item
	// These values are used as fallovers. If any of the variables aren't defined in the item,
	// it will use the defaults from here.
	// -----------------------------------------------------------------------
	// The name of the item (can be changed by admin)
    var $name = "No Name Specified";
	// The description of the item (can be changed)
    var $desc = "No Description Specified";
	// The default price (can be changed)
    var $price = 20;

	// The name of the author
	var $authorName = 'Unknown Author';
	// The author's web address
	var $authorWeb = 'Unknown Website';
	// The email address of the author
	var $authorEmail = 'Unknown Email Address';

	// Whether the item requires additional input or not
	// SMFShop versions before 1.0 (I think) always accepted input, regardless
	// Because of this, this value is set to 'true' for backwards compatibility
    var $require_input = true; 
	// Whether the item is 'usable' (most items) or not (a rock :D)
    var $can_use_item = true;

	// -----------------------------------------------------------------------

	// All of the stuff below is in the items:

    // This is called when we need to get the item details.
	// Here, you should fill in the $name, $desc and $price variables.
    function getItemDetails() {
		// You use the function like this:

		// $this->name = "Name";
		// $this->desc = "Description";
		// etc.
	}
    
    // This is called when person is adding this item to their SMFShop installation via the admin
    // panel. If you need any additional fields, then return them here
	// Any inputs should be called info1, info2, info3 and info4
	// See AddToPostCount.php for a working demo
    function getAddInput() {
		// Example:
		
		// return "Some input that the admin fills in: <input type='text' name='info1' />";
	}

    //This is called when person tries to use item. This is used to get input for the item.
    // If item needs no input then just return false here
	// Call the fields whatever you want, as they're passed straight to the onUse() function (via the $_POST array)
    function getUseInput() {
		// Example:
		
		// If input needed:
		// return "Enter your name: <input type='text' name='name' />";

		// If no input needed:
		// return false;
	}

    // This is called when item is actually used
	// The input fields in the getUseInput() function are passed here in the $_POST array
	// The admin fields in the getAddInput() function are passed in the $item_info array
    function onUse() {
		// See the items for an example
		// For an example of an item that uses getAddInput(), see AddToPostCount.php
		// For an example of an item that uses getUseInput(), see ChangeDisplayName.php 
	}
}

?>
